// -*- c++ -*-
// Generated by assa-genesis
//------------------------------------------------------------------------------
// $Id: MainWindow.h,v 1.23 2004/07/22 12:10:04 vlg Exp $
//------------------------------------------------------------------------------
//                            MainWindow.h
//------------------------------------------------------------------------------
//  Copyright (c) 2004 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Wed Dec 31 23:18:34 2003
//
//------------------------------------------------------------------------------
#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#ifdef HAVE_CONFIG_H
#    include "config.h"
#endif

#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/menubar.h>

#include "TopMenuBar.h"
#include "DeckManager.h"
#include "CardBox.h"
#include "VDeck.h"

class PrefWindow;
class AboutGRAPP;
class Deck;

class MainWindow : public Gtk::Window
{
public:
    MainWindow ();
    ~MainWindow ();

	/** Post-c'tor initialization
	 */
	void init ();

	// -*- Toolbar Callbacks -*-
	void about_cb   ();

	// [File] Menu
	void pref_cb    ();
    void exit_cb    ();

    // [CardFile] Menu
    void new_cb     ();
    void open_cb    ();
    void open_recent_cb (guint index_);	// set in TopMenuBar
    void save_cb    ();
    void save_as_cb ();
    void close_cb   ();
	void play_in_box (int idx_);

	// [Deck] Menu
	void unselect_deck_cb ();

	void set_mw_name ();
	virtual int delete_event_impl (GdkEventAny* event);

	DeckManager* get_deck_manager () { return &m_deck_manager; }
	DeckList*    get_deck_list    () { return m_deck_list;     }
	CardBox*     get_cardbox      () { return m_cardbox;       }
	PrefWindow*  get_pref_window  () { return m_pref_window;   }
	TopMenuBar*  get_top_menubar  () { return &m_top_menu_bar;  }

	friend void CardBox::add_deck_to_box  (int idx_, Deck* from_deck_);
	friend void CardBox::move_card_to_box (VDeck::cardlist_iterator card_ref_,
										   int from_deck_, 
										   int to_deck_,
										   bool is_expired_);
	friend void CardBox::add_card_to_box  (CardRef* card_ref_);

	void set_dnd_source (Deck* deck_) { m_dnd_source = deck_; }
	Deck* get_dnd_source () { return m_dnd_source; }

private:
	// -*- Utilities -*-
    void install_menus_and_toolbar ();
    void print_state (void) const;

    // -*- Internal actions -*-
    int  open_file    ();
    int  save_file    ();
    void save_file_as ();
	void close_file   ();
	void go_state (WMState state_);
	bool change_preferences ();

private:
	static const char* states [];

	WMState       m_state;
    Gtk::VBox     m_contents;
	DeckManager   m_deck_manager;
	TopMenuBar    m_top_menu_bar;
	Gtk::Widget*  m_open_item;
	string        m_app_title;
	DeckList*     m_deck_list;
	CardBox*      m_cardbox;	// Tray with cardboxes
	PrefWindow*   m_pref_window;
	AboutGRAPP*   m_about;		// 'About' dialog
	Deck*         m_dnd_source;
};

#endif // MAIN_WINDOW_H

